#pragma once

#include <map>
#include <mutex>

#include "accessor.h"



/* Mapping type from file identifiers to accessors. */

typedef std::map<fileid_t, Accessor *> FileMapping;
typedef std::pair<fileid_t, Accessor *> FileMappingEntry;



/* A registry of accessors for files. */

class Accessing
{
protected:
    FileMapping _accessors;
    std::mutex _lock;

public:
    bool reserve(fileid_t fileid);

    Accessor *get(fileid_t fileid);

    void set(fileid_t fileid, Accessor *accessor);
};

// vim: tabstop=4 expandtab shiftwidth=4
